if(!require(dplyr))install.packages("pheatmap")

rm(list = ls())
options(stringsAsFactors = F)

conNum <- 6       #normal组样品数目
tumorNum <- 122       #tumor组样品数目


hmExp <- read.table("diffExprSet_GSE83148_logFCcutoff_1_adjPcutoff_0.05.txt",sep="\t",header=T,check.names=F,row.names=1)
#hmExp=log2(hmExp+0.001)

#绘制差异基因热图
library(pheatmap)
Type=c(rep("Normal", conNum),rep("HBV", tumorNum))
names(Type)=colnames(hmExp)
Type=as.data.frame(Type)
pdf(file="heatmap.pdf", width = 8, height = 7)
pheatmap(hmExp, 
         annotation=Type, 
         color = colorRampPalette(c("blue", "white", "red"))(50),
         cluster_cols = F,
         show_colnames = F,
         show_rownames = F,
         scale = "row",
         fontsize = 12,
         fontsize_row=3,
         fontsize_col=10)
dev.off()
