if(!require(dplyr))install.packages("dplyr")
if(!require(GEOquery))BiocManager::install("GEOquery")

rm(list = ls())
options(stringsAsFactors = F)
# 填入需要下载的GSE编号
GSE_ID <- "GSE83148"
GSE_file <- paste0(GSE_ID, "_expr_df.rda")
library(GEOquery)
if(!file.exists(GSE_file)){
  # 1.下载表达矩阵和临床信息
  eSet <- getGEO(GSE_ID, destdir = '.', getGPL = F)
  # (1) 提取表达矩阵，查看表达矩阵，看是否需要取log2
  probes_expr <- exprs(eSet[[1]]);dim(probes_expr)
  (View(probes_expr[,1:4]))
  boxplot(probes_expr[,1:20],las=2)
  #probes_expr <- log2(probes_expr+1)
  # (2) 提取临床信息
  phenoDat <- pData(eSet[[1]])
  head(phenoDat[,1:4])
  # (3) 调整临床信息的行名顺序与表达矩阵列名完全一致
  probes_expr <- probes_expr[,row.names(phenoDat)]
  
  # 2.探针id转换为symbol
  (gpl <- eSet[[1]]@annotation)
  if(!require(hgu133plus2.db))BiocManager::install("hgu133plus2.db")
  library(hgu133plus2.db)
  probe2symbol_df <- toTable(get("hgu133plus2SYMBOL"))
  
  library(dplyr)
  genes_expr <- probes_expr %>% 
    merge(probe2symbol_df, ., by.x="probe_id", by.y=0) %>%
    select(-probe_id) %>%
    select(symbol, everything()) %>% 
    mutate(rowMean = rowMeans(.[grep("GSM", names(.))])) %>%
    arrange(desc(rowMean)) %>%
    distinct(symbol,.keep_all = T) %>%
    select(-rowMean) %>%
    tibble::column_to_rownames(colnames(.)[1])
  
  save(genes_expr, phenoDat, file = paste0(GSE_ID,"_expr_df.rda"))
  
}
