if(!require(stringr))install.packages("stringr")
if(!require(limma))BiocManager::install("limma")

rm(list = ls())
library(limma)
load("GSE83148_expr_df.rda")
GSE_ID <- "GSE83148"
# 分组信息
phe <- phenoDat[!is.na(phenoDat$source_name_ch1),]
phe <- phe[,c("geo_accession", "source_name_ch1")]
genes_expr2 <- genes_expr[,row.names(phe)]
boxplot(genes_expr2[,1:10])
genes_expr2 <- normalizeBetweenArrays(genes_expr2)
boxplot(genes_expr2[,1:10])

group <- factor(c(rep("tumor", 122), rep("normal", 6)))
design <- model.matrix(~0 + group)
colnames(design) <- levels(group)
design
contrast.matrix <- makeContrasts(tumor - normal, levels=design)
contrast.matrix
fit <- lmFit(genes_expr2, design)
fit2 <- contrasts.fit(fit, contrast.matrix) 
fit2 <- eBayes(fit2)
# 提取差异结果，注意这里的coef是1
allDiff <- topTable(fit2, adjust='fdr', coef=1, number=Inf) 
# 得到全部基因差异情况列表
allDiff2 <- rbind(id=colnames(allDiff), allDiff)
write.table(allDiff2, file = paste0("allDiff_", GSE_ID, ".txt"), col.names = F, sep = '\t', quote = F)

# 提取差异基因
fcFilter <- 1
pvalFilter <- 0.05
diffTab <- allDiff[abs(allDiff$logFC)>fcFilter & allDiff$adj.P.Val<pvalFilter,]
# 标注上下调情况
diffTab$change <- ifelse(diffTab$logFC>0, "up", "down")
# 得到差异基因列表
diffTab2 <- rbind(id=colnames(diffTab), diffTab)
write.table(diffTab2, file = paste0("diffTab_", GSE_ID, "_logFCcutoff_", fcFilter, "_adjPcutoff_", pvalFilter, ".txt"), col.names = F, sep = '\t', quote = F)
