if(!require(ggplot2)) install.packages("ggplot2")
if(!require(ggrepel)) install.packages("ggrepel")
if(!require(dplyr))install.packages("dplyr")
library(ggplot2)
library(ggrepel)
library(dplyr)

data <- read.table("allDiff_GSE83148.txt",header = T,sep = "\t")
data$change = ifelse(data$adj.P.Val < 0.05 & abs(data$logFC) >= 1, 
                     ifelse((data$logFC)> 1 ,'Up','Down'),
                     'Stable')

p <- ggplot(data = data, 
            aes(x = logFC, 
                y = -log10(adj.P.Val))) +
  geom_point(alpha=0.4, size=3.5, 
             aes(color=change)) +
  scale_color_manual(values=c("blue", "grey","red"))+
  geom_vline(xintercept=c(-1,1),lty=4,col="black",lwd=0.8) +
  geom_hline(yintercept = -log10(0.05),lty=4,col="black",lwd=0.8) +
  theme_bw()
p

for_label <- data %>% 
  filter(abs(logFC) >2& -log10(adj.P.Val) > -log10(0.01))

p1 <- p +
  geom_point(size = 3, shape = 1, data = for_label) +
  ggrepel::geom_label_repel(
    aes(label = id),
    data = for_label,
    color="black"
  )

ggsave(p1,filename = "volcano.pdf",width = 9, height = 8)
