#if (!requireNamespace("BiocManager", quietly = TRUE))
# install.packages("BiocManager")
#BiocManager::install("clusterProfiler")

#if (!requireNamespace("BiocManager", quietly = TRUE))
#  install.packages("BiocManager")

#BiocManager::install("org.Hs.eg.db")

#if (!requireNamespace("BiocManager", quietly = TRUE))
#  install.packages("BiocManager")

#BiocManager::install("DOSE")

rm(list = ls())
library(clusterProfiler)
library(ggplot2)

diffLab <- read.table("diff.txt",header = T,sep = "\t")
gene <- diffLab[,1]
gene <- bitr(gene, 
             fromType="SYMBOL", toType="ENTREZID", 
             OrgDb="org.Hs.eg.db")
head(gene)

###################GO###################
ego <- enrichGO(gene = gene$ENTREZID,
                OrgDb= org.Hs.eg.db, 
                ont = "all", 
                pAdjustMethod = "BH",
                pvalueCutoff = 0.01, 
                qvalueCutoff = 0.05,
                readable = TRUE)

#**作图**
#条带图
barplot(ego)
# 点图
dotplot(ego)

ego_results <- ego@result
write.table(ego_results, file="enrichGO.txt", sep="\t", quote=F, row.names = F)
#柱状图
pdf(file="barplot.pdf", width = 10, height = 8)
barplot(ego, drop = TRUE, showCategory =10, split="ONTOLOGY") + facet_grid(ONTOLOGY~., scale='free')
dev.off()
#气泡图
pdf(file="dotplot.pdf", width = 10, height = 8)
dotplot(ego, showCategory = 10, split="ONTOLOGY") + facet_grid(ONTOLOGY~., scale='free')
dev.off()

###################KEGG###################
kk <- enrichKEGG(gene         = gene$ENTREZID,
                 organism     = 'hsa',
                 pvalueCutoff = 0.05,
                 qvalueCutoff = 0.05)
kk_results <- kk@result
write.table(kk_results,file="enrichKEGG.txt", sep="\t", quote=F, row.names = F)
#柱状图
pdf(file="barplot_KEGG.pdf", width = 10, height = 7)
barplot(kk, drop = TRUE, showCategory = 30)
dev.off()
#气泡图
pdf(file="dotplot_KEGG.pdf", width = 10, height = 8)
dotplot(kk, showCategory = 30)
dev.off()
